/* $Id: Sinpsp.java,v 1.9 2010/09/25 07:11:42 mit Exp $ */
/* Sin35.java to Sinpsp.java v1.3 */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Sinpsp extends Applet implements AdjustmentListener
{
    private Scrollbar scrS;
    private Scrollbar scrP;

    static int L = 20;      // Ǹϰ
    static int P = 20;      // ܲ
    static int F = 62;      // 1ʬ
    static double T = 2d*Math.PI/F; 

    int W;
    int H;
    int LeftSide;
    int DownSide;
    int Spoint;
    int Part;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
	setLayout(new BorderLayout());

        Panel p = new Panel();
        p.setLayout(new GridLayout(2,2,0,0));

        scrS = new Scrollbar(Scrollbar.HORIZONTAL,8,1,2,L+1);
        p.add(scrS);
	scrS.addAdjustmentListener(this);

	p.add(new Label(" : Striking Point"));
	
	scrP = new Scrollbar(Scrollbar.HORIZONTAL,P,1,1,P+1);
	p.add(scrP);
	scrP.addAdjustmentListener(this);

        p.add(new Label(" : Partial"));

        add(p, "South");
    }
    public void start() {
	W = getSize().width;
        H = getSize().height;
	LeftSide = (int)(W/(double)P);
	DownSide = (int)(H/4.0*3);
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
        repaint();
    }

    public void update(Graphics g) {
        paint(g);
    }
    public void paint(Graphics g) {
	Spoint = scrS.getValue();
	Part = scrP.getValue();

	g.setColor(Color.black);
        g.fillRect(0, 0, W, H);

	g.setColor(Color.blue);
        g.drawLine(0, DownSide, W, DownSide);
	g.drawLine(LeftSide, 0, LeftSide, H);

	g.setColor(Color.red);
	g.drawString("Striking Point: 1/"+Spoint, 20, 20);
	g.drawString("Partial: "+Part, (int)(W*2.0/3), 20);

	disp_partial(g);
	disp_wave(g);
    }

    public void disp_partial(Graphics g) {
	double y1, xd = (W-LeftSide)/(double)P;
	int wide = (int)(xd/5);
	int x1, dh = 2*H;

	for (int i = 1; i <= Part; i++) { // disp.partial
	    x1 = (int)(LeftSide+i*xd);
	    y1 = Math.abs(yys(i)*dh);

	    g.setColor(Color.green); // partial
	    g.fillRect(x1-1, (int)(DownSide-y1), wide, (int)y1);

	    g.setColor(Color.blue); // memori
	    g.drawLine(x1, DownSide, x1, DownSide+8);

	    if (i % 5 == 0) { // 1-5-10-
		g.drawLine(x1, DownSide, x1, DownSide+16);

		g.setColor(Color.magenta);
		g.drawString(""+i, x1, DownSide+26);
	    }
	}
    }
    public void disp_wave(Graphics g) {
	int fh = (int)(2.0*H/3);
	int ch = (int)(H*2/5d);
	double fw = (W-LeftSide)/(double)F;

	g.setColor(Color.gray);
	g.drawLine(0, ch, W, ch);

	double[] sum = calc_wave();

	g.setColor(Color.white);      // disp.wave
	double x0, y0, x1 = 0, y1 = 0;
	for (int i = 0; i <= F; i++) {  
	    x0 = LeftSide+fw*i;
	    y0 = ch-fh*sum[i];
	    if (i == 0) {
		x1 = x0;
		y1 = y0;
		continue;
	    }
	    g.drawLine((int)x0, (int)y0, (int)x1, (int)y1);
	    x1 = x0;
	    y1 = y0;
	}
    }
    public double[] calc_wave() {
	double[] sum = new double[F+1];

	for (int j = 0; j <= F; j++) { // F+1
	    for (int i = 1; i <= Part; i++)    // 1~<=
		sum[j] += Math.sin(T*j*i) * Math.abs(yys(i));
	}

	return sum;
    }
    public double yys(int mm) {
	double mp = mm * Math.PI;
	return Math.sin(mp/Spoint)/mp; // Y
    }
}
